/*
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

/*
 Agent localizations
 */
define([
    'dojo/_base/lang',
    'aps/common'
], function (
    lang,
    apsCommon
) {
    var agentsInfo = {
            windows: {
                icon: 'images/agents_icon/win.svg'
            },
            windows_server: {
                icon: 'images/agents_icon/win.svg'
            },
            apple: {
                icon: 'images/agents_icon/mac.svg'
            },
            linux: {
                icon: 'images/agents_icon/linux.svg'
            },
            android: {
                icon: 'images/agents_icon/android.svg'
            },
            ios: {
                icon: 'images/agents_icon/mac.svg'
            },
            hyperv: {
                icon: 'images/agents_icon/win.svg'
            },
            vmware: {
                icon: 'images/agents_icon/vmware.svg'
            },
            pcs: {
                icon: 'images/agents_icon/virtuozzo.svg'
            },
            ad: {
                icon: 'images/agents_icon/win.svg'
            },
            sql: {
                icon: 'images/agents_icon/sql.svg'
            },
            exchange: {
                icon: 'images/agents_icon/exchange.svg'
            }
        },
        categoriesInfo = {
            workstations: {
                title: _('Workstations')
            },
            servers: {
                title: _('Servers')
            },
            virtualizationHosts: {
                title: _('Virtualization Hosts')
            },
            mobileDevices: {
                title: _('Mobile Devices')
            },
            applications: {
                title: _('Applications')
            }
        };

    return {
        buildBackupAgentsList: function (agentsResponse) {
            var categories = {};

            apsCommon.forEach(agentsResponse, function (agent, agentId) {
                var categoryName = agent.category,
                    agentInfo = agentsInfo[agentId];

                if (agentInfo === undefined) {
                    return;
                }

                agent = lang.mixin(agent, agentInfo, {
                    id: agentId
                });
                delete agent.category;

                if (categories[categoryName] === undefined) {
                    var categoryInfo = categoriesInfo[categoryName];
                    categories[categoryName] = lang.mixin(categoryInfo, {
                        category: categoryName,
                        agents: []
                    });
                }

                categories[categoryName].agents.push(agent);
            });

            return Object.values(categories);
        }
    };
});
