/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

require([
    "aps/load",
    "aps/xhr",
    "dojo/promise/all",
    "./js/common.js",
    "./js/messages.js",
    "./js/viewUser.js"
], function (load, xhr, all, common, messages, viewUser) {
    var tenant = aps.context.vars.tenant,
        user = aps.context.params.user,
        accountDefer = xhr.get("/aps/2/resources/" + tenant.aps.id + "/users?eq(serviceUserId," + user.aps.id + ")"),
        profileDefer = xhr.get("/aps/2/resources/" + tenant.aps.id + "/profile")

    all({
        accounts: accountDefer,
        profiles: profileDefer
    }).then(function (response) {
        var userQuota = response.profiles && response.profiles.length ? response.profiles[0].userQuota : common.USER_QUOTA.STRICT,
            account = response.accounts[0];
        account.notifications = account.notifications || [];

        xhr.get("/aps/2/resources/" + account.aps.id + "/updateStatistics").then(function(statistics){
            var result = viewUser.renderControls(account, user, false, userQuota, tenant, statistics);
            load(result);
        })

    }, messages.displayError);
});
