/*
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

define([
    'aps/Tile',
    './../utils',
    './../widgets/base/Output'
], function (
    Tile,
    utils,
    Output
) {

    return function (downloadView, enduserId) {
        enduserId = enduserId ? enduserId : null;
        var tile = new Tile({
            title: _('Protection Agents'),
            gridSize: 'md-6 xs-12',
            buttons: [
                {
                    type: 'default',
                    label: _('Download Agents'),
                    autoBusy: false,
                    onClick: function () {
                        aps.apsc.gotoView(downloadView, enduserId, {});
                    }
                }
            ]
        });
        tile.addChild(new Output({
            escapeHTML: true,
            content: '<ol type=\'1\' ><li style=\'font-weight: bold;\'>${downloadTitle}</li>${downloadText}' +
            '<li style=\'font-weight: bold;\'>${installTitle}</li>${installText}' +
            '<li style=\'font-weight: bold;\'>${protectTitle}</li>${protectText}',
            downloadTitle: _('Download'),
            downloadText: _('Download the protection agent installer.'),
            installTitle: _('Install'),
            installText: _('Install the agent on your device. During the installation, specify your service user login and password.'),
            protectTitle: _('Protect'),
            protectText: _('After the installation, protect your device by applying a protection plan to it.')
        }));
        return tile;
    };
});
