<?php
/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Base;

use Acronis\App\Utils\CacheableTrait;

trait GroupIdConverterTrait
{
    use CacheableTrait;

    public function convertToTenantId($groupId, \Service_MspApiClient_ApiInterface $mspApi)
    {
        if (!is_numeric($groupId)) {
            return $groupId;
        }

        return $this->fromCache(function () use ($groupId, $mspApi) {
            $group = $mspApi->getGroupById($groupId);
            return $group->getUuid();
        }, null, false, $groupId . '-' . $mspApi->getUrl());
        // todo refactor and use SimpleComositeKey in all memoize / fromCahe
    }
}