<?php
/**
 * @Copyright © 2002-2020 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Folders;

use Acronis\App\Base\GenericException;
use Acronis\App\Base\SimpleCompositeKey;

class FolderKey extends SimpleCompositeKey
{
    protected $delimiter = ':';

    public function __construct($parentId, $folderName)
    {
        if (!is_string($parentId) && strlen($parentId) !== 36) {
            throw new GenericException(sprintf('Incorrect $parentId "%s" provided, must be a string of length 36.', $parentId));
        }

        if (!preg_match('/^[A-Z]{2}$/', $folderName) && $folderName !== \Model_Resource_Tenant_Customer::DEFAULT_FOLDER_NAME) {
            throw new GenericException(sprintf(
                'Incorrect $folderName "%s" provided, must be a string of 2 uppercase latin letters / "%s".',
                $folderName, \Model_Resource_Tenant_Customer::DEFAULT_FOLDER_NAME
            ));
        }

        parent::__construct([$parentId, $folderName]);
    }
}