<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

/**
 * Class Model_Resource_Tenant_Customer
 */
trait Model_Resource_SubscriptionResourcesTrait
{
    protected function fetchSubscriptionResources()
    {
        return $this->tenant->subscription->resources();
    }

    protected function fetchSubscriptionCounterNames()
    {
        $counterResources = array_filter($this->fetchSubscriptionResources(), function($resource) {
            return Arr::has($resource, 'property');
        });

        return array_map(function($resource) {
            return Arr::get($resource, 'property');
        }, $counterResources);
    }

    protected function fetchSubscriptionCounters()
    {
        return array_map(function($counterName) {
            $counter = $this->getCountersManager()->getCounterByName($counterName);

            if (is_null($counter)) {
                throw new RuntimeException(Str::format(
                    'Unknown counter %s is present in list of subscription resources.', $counterName
                ));
            }

            return $counter;
        }, $this->fetchSubscriptionCounterNames());
    }
}