<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

abstract class Service_BaseClient_Request_Base
    implements Service_BaseClient_Request_IRequest
{
    const METHOD_GET = 'GET';
    const METHOD_POST = 'POST';
    const METHOD_PUT = 'PUT';
    const METHOD_DELETE = 'DELETE';

    /** @var string */
    protected $_resource = null;
    /** @var string */
    protected $_method = null;
    /** @var Service_BaseClient_Request_Struct_IArrayRepresentation */
    protected $_requestObject = null;
    /** @var array */
    protected $_headers = [];

    /**
     * @return Service_BaseClient_TransportStrategy_ITransportStrategy
     */
    public function getSendingStrategy()
    {
        return new Service_BaseClient_TransportStrategy_Simple();
    }

    /**
     * @return null
     */
    public function getRequestBody()
    {
        return $this->_requestObject;
    }

    /**
     * @param mixed $requesBody
     */
    public function setRequestBody($requesBody)
    {
        $this->_requestObject = $requesBody;
    }

    /**
     * @return string
     */
    public function getMethod()
    {
        return $this->_method;
    }

    /**
     * @param string $method
     */
    public function setMethod($method)
    {
        $this->_method = $method;
    }

    /**
     * @return string
     */
    public function getResource()
    {
        return $this->_resource;
    }

    /**
     * @param string $resource
     */
    public function setResource($resource)
    {
        $this->_resource = $resource;
    }

    /**
     * @return array
     */
    public function getHeaders()
    {
        return $this->_headers;
    }

    /**
     * @param array $headers
     */
    public function setHeaders(array $headers)
    {
        $this->_headers = $headers;
    }
}
