<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_GetStoragesByGroupId extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/groups/%s/storages';

    /**
     * @param int|string $groupId
     */
    public function __construct($groupId)
    {
        $this->_groupId = $groupId;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $groupId);
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_Storages
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_Storages($responseBody);
    }
}