<?php

/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_Struct_GroupPrivileges
    extends Service_BaseClient_Request_Struct_Updatable
{



















































































































// scripts_app_service_msp_api_client_request_struct_group_privileges_quota_constant this code is used for code generation, do not remove!
    const FIELD_WEB_HOSTING_SERVER_COUNT = 'web_hosting_server_count';
    const FIELD_WEBSITE_COUNT = 'website_count';
    const FIELD_MOBILE_COUNT = "mobile_count";
    const FIELD_MAILBOX_COUNT = "mailbox_count";
    const FIELD_WORKSTATION_COUNT = "workstation_count";
    const FIELD_SERVER_COUNT = "server_count";
    const FIELD_VM_COUNT = "vm_count";
    const FIELD_STORAGE_SIZE = "storage_size";
    const FIELD_LOCAL_STORAGE_SIZE = "local_storage_size";
    const FIELD_VIRTUALHOST_COUNT = 'virtualhost_count';
    const FIELD_WIN_SERVER_ESSENTIAL_COUNT = 'win_server_essential_count';
    const FIELD_UNIVERSAL_DEVICES_COUNT = 'universal_devices_count';

    const FIELD_LOCAL_BACKUP = "local_backup";
    const FIELD_CLOUD_TO_CLOUD_BACKUP = "cloud_to_cloud_backup";




















































































































// scripts_app_service_msp_api_client_request_struct_group_privileges_quota_hard_constant this code is used for code generation, do not remove!
    const FIELD_QUOTA_MOBILES_HARD = "quota_mobiles_hard";
    const FIELD_QUOTA_MAILBOX_HARD = "quota_mailboxes_hard";
    const FIELD_QUOTA_WEB_HOSTING_SERVERS_HARD = "quota_web_hosting_servers_hard";
    const FIELD_QUOTA_WEBSITES_HARD = "quota_websites_hard";
    const FIELD_QUOTA_WORKSTATIONS_HARD = "quota_workstations_hard";
    const FIELD_QUOTA_SERVERS_HARD = "quota_servers_hard";
    const FIELD_QUOTA_VMS_HARD = "quota_vms_hard";
    const FIELD_QUOTA_STORAGE_HARD = "quota_storage_hard";
    const FIELD_QUOTA_LOCAL_STORAGE_HARD = "quota_local_storage_hard";
    const FIELD_QUOTA_MAILBOX_INSTANCE_STORAGE = "quota_mailbox_instance_storage";
    const FIELD_QUOTA_VIRTUALHOSTS_HARD = 'quota_virtualhosts_hard';
    const FIELD_QUOTA_WIN_SERVER_ESSENTIALS_HARD = 'quota_win_server_essentials_hard';
    const FIELD_QUOTA_UNIVERSAL_DEVICES_HARD = 'quota_universal_devices_hard';

    const MSP_UNLIMITED = -1;




















































































































// scripts_app_service_msp_api_client_request_struct_group_privileges_variable this code is used for code generation, do not remove!
    /** @var  int */
    private $_webHostingServerCount;
    /** @var  int */
    private $_websiteCount;
    /** @var  int */
    private $_mobileCount;
    /** @var  int */
    private $_mailboxCount;
    /** @var  int */
    private $_workstationCount;
    /** @var  int */
    private $_serverCount;
    /** @var  int */
    private $_vmCount;
    /** @var  int */
    private $_storageSize;
    /** @var  int */
    private $_localStorageSize;
    /** @var  int */
    private $_mailboxInstanceStorageSize;
    /** @var  int */
    private $_virtualHostCount;
    /** @var  int */
    private $_winServerEssentialCount;
    /** @var  int */
    private $_universalDevicesCount;

    /** @var Service_MspApiClient_Request_Struct_LocalBackup */
    private $_localBackup;

    /** @var  int */
    private $_cloudToCloudBackup;

    public function __construct(array $updateMap = array())
    {
        parent::__construct($updateMap);
        $this->setLocalBackup(new Service_MspApiClient_Request_Struct_LocalBackup());
    }

    public function isExistsUpdateFields()
    {
        return parent::isExistsUpdateFields()
            || $this->getLocalBackup()->isExistsUpdateFields();
    }

    /**
     * @return array
     */
    public function toArray()
    {
        //TODO - separate hard/soft quotas
        $result = array();

        $count = $this->getStorageSize();
        if (!is_null($count)) {
            $result[self::FIELD_STORAGE_SIZE] = $count;
            $result[self::FIELD_QUOTA_STORAGE_HARD] = $count;
        }

        $count = $this->getLocalStorageSize();
        if (!is_null($count)) {
            $result[self::FIELD_LOCAL_STORAGE_SIZE] = $count;
            $result[self::FIELD_QUOTA_LOCAL_STORAGE_HARD] = $count;
        }

        $count = $this->getServerCount();
        if (!is_null($count)) {
            $result[self::FIELD_SERVER_COUNT] = $count;
            $result[self::FIELD_QUOTA_SERVERS_HARD] = $count;
        }

        $count = $this->getVmCount();
        if (!is_null($count)) {
            $result[self::FIELD_VM_COUNT] = $count;
            $result[self::FIELD_QUOTA_VMS_HARD] = $count;
        }

        $count = $this->getWorkstationCount();
        if (!is_null($count)) {
            $result[self::FIELD_WORKSTATION_COUNT] = $count;
            $result[self::FIELD_QUOTA_WORKSTATIONS_HARD] = $count;
        }

        $count = $this->getMobileCount();
        if (!is_null($count)) {
            $result[self::FIELD_MOBILE_COUNT] = $count;
            $result[self::FIELD_QUOTA_MOBILES_HARD] = $count;
        }

        $count = $this->getMailboxCount();
        if (!is_null($count)) {
            $result[self::FIELD_MAILBOX_COUNT] = $count;
            $result[self::FIELD_QUOTA_MAILBOX_HARD] = $count;
        }




















































































































// scripts_app_service_msp_api_client_request_struct_group_privileges_logic this code is used for code generation, do not remove!
        $count = $this->getWebHostingServerCount();
        if (!is_null($count)) {
            $result[self::FIELD_WEB_HOSTING_SERVER_COUNT] = $count;
            $result[self::FIELD_QUOTA_WEB_HOSTING_SERVERS_HARD] = $count;
        }

        $count = $this->getWebsiteCount();
        if (!is_null($count)) {
            $result[self::FIELD_WEBSITE_COUNT] = $count;
            $result[self::FIELD_QUOTA_WEBSITES_HARD] = $count;
        }

        $count = $this->getMailboxInstanceStorageSize();
        if (!is_null($count)) {
            $result[self::FIELD_QUOTA_MAILBOX_INSTANCE_STORAGE] = $count;
        }

        if ($this->getLocalBackup()->isExistsUpdateFields()) {
            $result[self::FIELD_LOCAL_BACKUP] = $this->getLocalBackup()->toArray();
        }

        $count = $this->getCloudToCloudBackup();
        if (!is_null($count)) {
            $result[self::FIELD_CLOUD_TO_CLOUD_BACKUP] = $count;
        }

        $count = $this->getVirtualHostCount();
        if (!is_null($count)) {
            $result[self::FIELD_VIRTUALHOST_COUNT] = $count;
            $result[self::FIELD_QUOTA_VIRTUALHOSTS_HARD] = $count;
        }

        $count = $this->getWinServerEssentialCount();
        if (!is_null($count)) {
            $result[self::FIELD_WIN_SERVER_ESSENTIAL_COUNT] = $count;
            $result[self::FIELD_QUOTA_WIN_SERVER_ESSENTIALS_HARD] = $count;
        }

        $count = $this->getUniversalDevicesCount();
        if (!is_null($count)) {
            $result[self::FIELD_UNIVERSAL_DEVICES_COUNT] = $count;
            $result[self::FIELD_QUOTA_UNIVERSAL_DEVICES_HARD] = $count;
        }

        return $result;
    }

    /**
     * @param int $serverCount
     */
    public function setServerCount($serverCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_SERVER_COUNT);
        $this->_serverCount = $serverCount;
    }

    /**
     * @return int
     */
    public function getServerCount()
    {
        return $this->_serverCount;
    }

    /**
     * @param int $storageSize
     */
    public function setStorageSize($storageSize)
    {
        $this->_markFieldAsUpdated(self::FIELD_STORAGE_SIZE);
        $this->_storageSize = $storageSize;
    }

    /**
     * @return int
     */
    public function getStorageSize()
    {
        return $this->_storageSize;
    }

    /**
     * @param int $vmCount
     */
    public function setVmCount($vmCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_VM_COUNT);
        $this->_vmCount = $vmCount;
    }

    /**
     * @return int
     */
    public function getVmCount()
    {
        return $this->_vmCount;
    }

    /**
     * @param int $workstationCount
     */
    public function setWorkstationCount($workstationCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_WORKSTATION_COUNT);
        $this->_workstationCount = $workstationCount;
    }

    /**
     * @return int
     */
    public function getWorkstationCount()
    {
        return $this->_workstationCount;
    }

    /**
     * @return int
     */
    public function getMobileCount()
    {
        return $this->_mobileCount;
    }

    /**
     * @param int $mobileCount
     */
    public function setMobileCount($mobileCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_MOBILE_COUNT);
        $this->_mobileCount = $mobileCount;
    }

    /**
     * @return int
     */
    public function getMailboxCount()
    {
        return $this->_mailboxCount;
    }

    /**
     * @param int $mailboxCount
     */
    public function setMailboxCount($mailboxCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_MAILBOX_COUNT);
        $this->_mailboxCount = $mailboxCount;
    }




















































































































// scripts_app_service_msp_api_client_request_struct_group_privileges_getter_and_setter this code is used for code generation, do not remove!
    /**
     * @return int
     */
    public function getWebHostingServerCount()
    {
        return $this->_webHostingServerCount;
    }

    /**
     * @param int $webHostingServerCount
     */
    public function setWebHostingServerCount($webHostingServerCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_WEB_HOSTING_SERVER_COUNT);
        $this->_webHostingServerCount = $webHostingServerCount;
    }
    /**
     * @return int
     */
    public function getWebsiteCount()
    {
        return $this->_websiteCount;
    }

    /**
     * @param int $websiteCount
     */
    public function setWebsiteCount($websiteCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_WEBSITE_COUNT);
        $this->_websiteCount = $websiteCount;
    }

    /**
     * @return Service_MspApiClient_Request_Struct_LocalBackup
     */
    public function getLocalBackup()
    {
        return $this->_localBackup;
    }

    /**
     * @param  $localBackup
     */
    public function setLocalBackup($localBackup)
    {
        $this->_localBackup = $localBackup;
    }

    /**
     * @return int
     */
    public function getMailboxInstanceStorageSize()
    {
        return $this->_mailboxInstanceStorageSize;
    }

    /**
     * @param int $mailboxStorageSize
     */
    public function setMailboxInstanceStorageSize($mailboxStorageSize)
    {
        $this->_markFieldAsUpdated(self::FIELD_QUOTA_MAILBOX_INSTANCE_STORAGE);
        $this->_mailboxInstanceStorageSize = $mailboxStorageSize;
    }

    /**
     * @return int
     */
    public function getCloudToCloudBackup()
    {
        return $this->_cloudToCloudBackup;
    }

    /**
     * @param int $cloudToCloudBackup
     */
    public function setCloudToCloudBackup($cloudToCloudBackup)
    {
        $this->_markFieldAsUpdated(self::FIELD_CLOUD_TO_CLOUD_BACKUP);
        $this->_cloudToCloudBackup = $cloudToCloudBackup;
    }

    /**
     * @return int
     */
    public function getLocalStorageSize()
    {
        return $this->_localStorageSize;
    }

    /**
     * @param int $localStorageSize
     */
    public function setLocalStorageSize($localStorageSize)
    {
        $this->_markFieldAsUpdated(self::FIELD_LOCAL_STORAGE_SIZE);
        $this->_localStorageSize = $localStorageSize;
    }

    /**
     * @return int
     */
    public function getVirtualHostCount()
    {
        return $this->_virtualHostCount;
    }

    /**
     * @param int $virtualHostCount
     */
    public function setVirtualHostCount($virtualHostCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_VIRTUALHOST_COUNT);
        $this->_virtualHostCount = $virtualHostCount;
    }

    /**
     * @return int
     */
    public function getWinServerEssentialCount()
    {
        return $this->_winServerEssentialCount;
    }

    /**
     * @param int $winServerEssentialCount
     */
    public function setWinServerEssentialCount($winServerEssentialCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_WIN_SERVER_ESSENTIAL_COUNT);
        $this->_winServerEssentialCount = $winServerEssentialCount;
    }

    /**
     * @return int
     */
    public function getUniversalDevicesCount()
    {
        return $this->_universalDevicesCount;
    }

    /**
     * @param int $universalDevicesCount
     */
    public function setUniversalDevicesCount($universalDevicesCount)
    {
        $this->_markFieldAsUpdated(self::FIELD_UNIVERSAL_DEVICES_COUNT);
        $this->_universalDevicesCount = $universalDevicesCount;
    }
}





