<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Request_Struct_RequestUsageReport implements Service_BaseClient_Request_Struct_IArrayRepresentation, Service_MspApiClient_Request_Struct_UsageReportInterface
{
    const FIELD_WHEN = 'when';
    const FIELD_KIND = 'kind';
    const FIELD_BEGIN_DATE = 'begin_date';
    const FIELD_END_DATE = 'end_date';
    const FIELD_RESULT_ACTION = 'result_action';
    const FIELD_LEVEL = 'level';

    const RESULT_ACTION_SAVE = 'save';
    const WHEN_ASAP = 0;
    const KIND_DAILY = 4;
    const KIND_SUMMARY = 5;

    /**
     * Unix time
     * @var int
     */
    private $when;

    /**
     * @var int
     */
    private $kind;

    /**
     * Unix time
     * @var int
     */
    private $beginDate;

    /**
     * Unix time
     * @var int
     */
    private $endDate;

    /**
     * @var string
     */
    private $resultAction;

    /**
     * Unix time
     * @var int
     */
    private $level;

    /**
     * @return int
     */
    public function getWhen()
    {
        return $this->when;
    }

    /**
     * @param int $when
     */
    public function setWhen($when)
    {
        $this->when = $when;
    }

    /**
     * @return int
     */
    public function getKind()
    {
        return $this->kind;
    }

    /**
     * @param int $kind
     */
    public function setKind($kind)
    {
        $this->kind = $kind;
    }

    /**
     * @return int
     */
    public function getBeginDate()
    {
        return $this->beginDate;
    }

    /**
     * @param int $beginDate
     */
    public function setBeginDate($beginDate)
    {
        $this->beginDate = $beginDate;
    }

    /**
     * @return int
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * @param int $endDate
     */
    public function setEndDate($endDate)
    {
        $this->endDate = $endDate;
    }

    /**
     * @return string
     */
    public function getResultAction()
    {
        return $this->resultAction;
    }

    /**
     * @param string $resultAction
     */
    public function setResultAction($resultAction)
    {
        $this->resultAction = $resultAction;
    }

    /**
     * @return int
     */
    public function getLevel()
    {
        return $this->level;
    }

    /**
     * @param int $level
     */
    public function setLevel($level)
    {
        $this->level = $level;
    }

    public function toArray()
    {
        $result = array();

        $result[self::FIELD_WHEN] = $this->getWhen();
        $result[self::FIELD_KIND] = $this->getKind();
        $result[self::FIELD_BEGIN_DATE] = $this->getBeginDate();
        $result[self::FIELD_END_DATE] = $this->getEndDate();
        $result[self::FIELD_RESULT_ACTION] = $this->getResultAction();
        $result[self::FIELD_LEVEL] = $this->getLevel();
        return $result;
    }
}
