<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

interface Service_MspApiClient_Request_Struct_UserInfoInterface
{
    const FIELD_LOGIN = 'login';
    const FIELD_LANGUAGE = 'language';
    const FIELD_EMAIL = 'email';
    const FIELD_FIRSTNAME = 'firstname';
    const FIELD_LASTNAME = 'lastname';
    const FIELD_NOTIFICATIONS_BACKUP = 'notifications_backup';
    const FIELD_NOTIFICATIONS_MANAGEMENT = 'notifications_management';
    const FIELD_PRIVILEGES = 'privileges';
    const FIELD_STATUS = 'status';
    const FIELD_PRIVILEGED = 'privileged';
    const FIELD_ROLES = 'roles';

    const STATUS_INACTIVE = -1;
    const STATUS_ENABLE = 1;
    const STATUS_DISABLE = 0;

    /**
     * @param string $email
     */
    public function setEmail($email);

    /**
     * @return string
     */
    public function getEmail();

    /**
     * @param string $firstName
     */
    public function setFirstName($firstName);

    /**
     * @return string
     */
    public function getFirstName();

    /**
     * @param string $lastName
     */
    public function setLastName($lastName);

    /**
     * @return string
     */
    public function getLastName();

    /**
     * @param Enum_NotificationsBackup $notificationsBackup
     */
    public function setNotificationsBackup(Enum_NotificationsBackup $notificationsBackup);

    /**
     * @return Enum_NotificationsBackup
     */
    public function getNotificationsBackup();

    /**
     * @param int $notificationsManagement
     */
    public function setNotificationsManagement($notificationsManagement);

    /**
     * @return int
     */
    public function getNotificationsManagement();

    /**
     * @param Service_MspApiClient_Request_Struct_UserPrivileges $privileges
     */
    public function setPrivileges(Service_MspApiClient_Request_Struct_UserPrivileges $privileges);

    /**
     * @return Service_MspApiClient_Request_Struct_UserPrivileges
     */
    public function getPrivileges();

    /**
     * @return int
     */
    public function getPrivileged();

    /**
     * @param int $privileged
     */
    public function setPrivileged($privileged);

    /**
     * @return int
     */
    public function getRoles();

    /**
     * @param int $roles
     */
    public function setRoles($roles);

    /**
     * @return string
     */
    public function getLanguage();

    /**
     * @param string $language
     */
    public function setLanguage($language);
}