<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_MspApiClient_Response_Struct_UsageReport
{
    /**
     * @var Service_MspApiClient_Response_Struct_UsageReportHeaders
     */
    private $params;

    /**
     * @var Service_MspApiClient_Response_Struct_UsageReportBodyItem[]
     */
    private $tenants;

    /**
     * @return Service_MspApiClient_Response_Struct_UsageReportHeaders
     */
    public function getParams()
    {
        return $this->params;
    }

    /**
     * @param Service_MspApiClient_Response_Struct_UsageReportHeaders $params
     */
    public function setParams($params)
    {
        $this->params = $params;
    }

    /**
     * @return Service_MspApiClient_Response_Struct_UsageReportBodyItem[]
     */
    public function getTenants()
    {
        return $this->tenants;
    }

    /**
     * @param Service_MspApiClient_Response_Struct_UsageReportBodyItem[] $tenants
     */
    public function setTenants(array $tenants)
    {
        $this->tenants = $tenants;
    }

    public function toArray()
    {
        return array(
            Service_MspApiClient_Response_GetUsageReport::PROPERTY_PARAMS => $this->params ? $this->params->toArray() : null,
            Service_MspApiClient_Response_GetUsageReport::PROPERTY_TENANTS => is_array($this->tenants)
                ? array_map(function ($tenant) {
                    /**
                     * @var Service_MspApiClient_Response_Struct_UsageReportBodyItem $tenant
                     */
                    return $tenant->toArray();
                }, $this->tenants)
                : $this->tenants
        );
    }
}
