<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Validator
{
    /** @var  Service_OpenApi_Validator_Factory */
    private $_factory;

    /**
     * @param Service_OpenApi_Validator_Factory $factory
     */
    public function __construct(Service_OpenApi_Validator_Factory $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_OpenApi_Validator_Factory() : $factory;
    }

    /**
     * @param mixed $decodedResponse
     * @param Service_OpenApi_Response_RawInterface $response
     * @throws Service_OpenApi_HttpTransport_ConnectionException
     * @return bool
     */
    public function validateResponse($decodedResponse, Service_OpenApi_Response_RawInterface $response)
    {
        $invalidStatus = $this->_factory->getInvalidStatus();
        $xmlFailure = $this->_factory->getXmlFailure($invalidStatus);
        $emptyResponse = $this->_factory->getEmptyResponse($xmlFailure);
        $invalidCode = $this->_factory->getInvalidCode($emptyResponse);
        return $invalidCode->handleResponse($decodedResponse, $response);
    }
} 
