<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetAccountListByCustomAttribute extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetOrder_API';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $data = $this->_getProperty(0, $responseArray);
        $accounts = array();
        foreach ($data as $item) {
            $account = new Service_PbaApi_Api_Response_Struct_GetAccountListByCustomAttribute();
            $account->setAccountId($this->_getProperty(0, $item));
            $account->setCompanyName($this->_getProperty(1, $item));
            $accounts[] = $account;
        }

        return $accounts;
    }
}
