<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetResource extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation GetResource';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $response = $this->_getProperty(0, $responseArray);

        /**
         * BMResourceGet(resourceID)
         * return=
         *   resourceID
         *   name
         *   ResourceCategoryResCatID
         *   description
         *   additive
         *   measurable
         *   postApprovalRequired
         *   measureUnitmeasureUnit
         *   AccountAccountID
         *   ServiceGateServiceGateGateID
         *   maxValue
         *   minValue
         *   displayType
         *   increment
         *   allowedValues
         *   allowedValuesList
         *   MaxControl
         *   Command
         *   isEditable
         *   isAlien
         *   resType
         *   canChangeMeasureUnit
         */

        $resource = new Service_PbaApi_Api_Response_Struct_GetResource();
        $resource->setId($this->_getProperty(0, $response));
        $resource->setName($this->_getProperty(1, $response));
        $resource->setResourceType($this->_getProperty(16, $response));

        return $resource;
    }
}
