<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_Struct_PlanRateListItem
{
    /**
     * Identifier of a resource rate.
     * @var int
     */
    private $resourceRateId;

    /**
     * Resource rate name.
     * @var str
     */
    private $resourceRateName;

    /**
     * Resource rate description.
     * @var str
     */
    private $description;

    /**
     * Amount of the resource units included into the specified service plan.
     * @var double
     */
    private $includedValue;

    /**
     * Upper limit of the resource consumption.
     * @var double
     */
    private $upperLimit;

    /**
     * Lower limit of the resource consumption.
     * @var double
     */
    private $lowerLimit;

    /**
     * Unit of measure applicable to this resource.
     * @var str
     */
    private $unitOfMeasure;

    /**
     * Setup fee for the resource usage.
     * @var double
     */
    private $setupFee;

    /**
     * Recurring fee for the resource usage.
     * @var double
     */
    private $recurringFee;

    /**
     * This parameter signifies if the resource is measurable (the values is 1) or not (0).
     * @var int
     */
    private $measurable;

    /**
     * Business Automation identifier of the resource.
     * @var int
     */
    private $resourceId;

    /**
     * Description of the resource setup fee, which is shown in the customer panel and online store.
     * @var str
     */
    private $setupFeeDescription;

    /**
     * Description of the recurring fee, which is shown in the customer panel and online store.
     * @var str
     */
    private $recurrFeeDescription;

    /**
     * This parameter signifies whether the resource rate is shown in the customer panel (the value is 1) or not (0).
     * @var int
     */
    private $isVisible;

    /**
     * This parameter signifies if the resource rate is shown in the online store (1) or not (0).
     * @var int
     */
    private $isMain;

    /**
     * The resource description that is shown in the online store.
     * @var str
     */
    private $storeText;

    /**
     * This parameter signifies if the setup fee is changed per unit (1) or not (0).
     * @var int
     */
    private $isSFperUnit;

    /**
     * This parameter signifies if the recurring fee is changed per unit (1) or not (0).
     * @var int
     */
    private $isRFperUnit;

    /**
     * This parameter signifies if the upgrade fee is changed per unit (1) or not (0).
     * @var int
     */
    private $isSFforUpgrade;

    /**
     * The resource price text shown in the store (for example, "5 Gb / month").
     * @var str
     */
    private $storePriceText;

    /**
     * Identifier of the category into which the resource is included.
     * @var int
     */
    private $resourceCategoryId;

    /**
     * This parameter defines in which order the resource is displayed in the resources list of the store.
     * @var int
     */
    private $sortOrder;

    /**
     * If applicable to this resource, the name of the group of resources that are incompatible and are to be selected with a radio-button.
     * @var str
     */
    private $radioGroupName;

    /**
     * The name of the parent resource, in case the resource depends on another resource (which is common for licensed services).
     * @var str
     */
    private $parentResourceName;

    /**
     * Description of the resource overusage fee.
     * @var str
     */
    private $overuseFeeDescription;

    /**
     * Resource overusage fee;
     * @var double
     */
    private $overuseFee;

    /**
     * This option signifies whether tiered pricing is applied to the resource Overuse fee (1) or not (0).
     * @var int
     */
    private $isOveruseFeeTiered;

    /**
     * This option signifies whether tiered pricing is applied to the resource Recurring fee (1) or not (0).
     * @var int
     */
    private $isRecurringFeeTiered;

    /**
     * This option signifies whether tiered pricing is applied to the resource Setup fee (1) or not (0).
     * @var int
     */
    private $isSetupFeeTiered;

    /**
     * This parameter defines the multiplier of the dependant resource.
     * For example, one mailbox requires 1024 KB of diskspace, so five mailboxes require 5120 KB, 1024 is multiplier
     * @var int
     */
    private $parentDependentMultiplier;

    /**
     * @return int
     */
    public function getResourceRateId()
    {
        return $this->resourceRateId;
    }

    /**
     * @param int $resourceRateId
     */
    public function setResourceRateId($resourceRateId)
    {
        $this->resourceRateId = $resourceRateId;
    }

    /**
     * @return str
     */
    public function getResourceRateName()
    {
        return $this->resourceRateName;
    }

    /**
     * @param str $resourceRateName
     */
    public function setResourceRateName($resourceRateName)
    {
        $this->resourceRateName = $resourceRateName;
    }

    /**
     * @return str
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param str $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @return float
     */
    public function getIncludedValue()
    {
        return $this->includedValue;
    }

    /**
     * @param float $includedValue
     */
    public function setIncludedValue($includedValue)
    {
        $this->includedValue = $includedValue;
    }

    /**
     * @return float
     */
    public function getUpperLimit()
    {
        return $this->upperLimit;
    }

    /**
     * @param float $upperLimit
     */
    public function setUpperLimit($upperLimit)
    {
        $this->upperLimit = $upperLimit;
    }

    /**
     * @return float
     */
    public function getLowerLimit()
    {
        return $this->lowerLimit;
    }

    /**
     * @param float $lowerLimit
     */
    public function setLowerLimit($lowerLimit)
    {
        $this->lowerLimit = $lowerLimit;
    }

    /**
     * @return str
     */
    public function getUnitOfMeasure()
    {
        return $this->unitOfMeasure;
    }

    /**
     * @param str $unitOfMeasure
     */
    public function setUnitOfMeasure($unitOfMeasure)
    {
        $this->unitOfMeasure = $unitOfMeasure;
    }

    /**
     * @return float
     */
    public function getSetupFee()
    {
        return $this->setupFee;
    }

    /**
     * @param float $setupFee
     */
    public function setSetupFee($setupFee)
    {
        $this->setupFee = $setupFee;
    }

    /**
     * @return float
     */
    public function getRecurringFee()
    {
        return $this->recurringFee;
    }

    /**
     * @param float $recurringFee
     */
    public function setRecurringFee($recurringFee)
    {
        $this->recurringFee = $recurringFee;
    }

    /**
     * @return int
     */
    public function getMeasurable()
    {
        return $this->measurable;
    }

    /**
     * @param int $measurable
     */
    public function setMeasurable($measurable)
    {
        $this->measurable = $measurable;
    }

    /**
     * @return int
     */
    public function getResourceId()
    {
        return $this->resourceId;
    }

    /**
     * @param int $resourceId
     */
    public function setResourceId($resourceId)
    {
        $this->resourceId = $resourceId;
    }

    /**
     * @return str
     */
    public function getSetupFeeDescription()
    {
        return $this->setupFeeDescription;
    }

    /**
     * @param str $setupFeeDescription
     */
    public function setSetupFeeDescription($setupFeeDescription)
    {
        $this->setupFeeDescription = $setupFeeDescription;
    }

    /**
     * @return str
     */
    public function getRecurrFeeDescription()
    {
        return $this->recurrFeeDescription;
    }

    /**
     * @param str $recurrFeeDescription
     */
    public function setRecurrFeeDescription($recurrFeeDescription)
    {
        $this->recurrFeeDescription = $recurrFeeDescription;
    }

    /**
     * @return int
     */
    public function getIsVisible()
    {
        return $this->isVisible;
    }

    /**
     * @param int $isVisible
     */
    public function setIsVisible($isVisible)
    {
        $this->isVisible = $isVisible;
    }

    /**
     * @return int
     */
    public function getIsMain()
    {
        return $this->isMain;
    }

    /**
     * @param int $isMain
     */
    public function setIsMain($isMain)
    {
        $this->isMain = $isMain;
    }

    /**
     * @return str
     */
    public function getStoreText()
    {
        return $this->storeText;
    }

    /**
     * @param str $storeText
     */
    public function setStoreText($storeText)
    {
        $this->storeText = $storeText;
    }

    /**
     * @return int
     */
    public function getIsSFperUnit()
    {
        return $this->isSFperUnit;
    }

    /**
     * @param int $isSFperUnit
     */
    public function setIsSFperUnit($isSFperUnit)
    {
        $this->isSFperUnit = $isSFperUnit;
    }

    /**
     * @return int
     */
    public function getIsRFperUnit()
    {
        return $this->isRFperUnit;
    }

    /**
     * @param int $isRFperUnit
     */
    public function setIsRFperUnit($isRFperUnit)
    {
        $this->isRFperUnit = $isRFperUnit;
    }

    /**
     * @return int
     */
    public function getIsSFforUpgrade()
    {
        return $this->isSFforUpgrade;
    }

    /**
     * @param int $isSFforUpgrade
     */
    public function setIsSFforUpgrade($isSFforUpgrade)
    {
        $this->isSFforUpgrade = $isSFforUpgrade;
    }

    /**
     * @return str
     */
    public function getStorePriceText()
    {
        return $this->storePriceText;
    }

    /**
     * @param str $storePriceText
     */
    public function setStorePriceText($storePriceText)
    {
        $this->storePriceText = $storePriceText;
    }

    /**
     * @return int
     */
    public function getResourceCategoryId()
    {
        return $this->resourceCategoryId;
    }

    /**
     * @param int $resourceCategoryId
     */
    public function setResourceCategoryId($resourceCategoryId)
    {
        $this->resourceCategoryId = $resourceCategoryId;
    }

    /**
     * @return int
     */
    public function getSortOrder()
    {
        return $this->sortOrder;
    }

    /**
     * @param int $sortOrder
     */
    public function setSortOrder($sortOrder)
    {
        $this->sortOrder = $sortOrder;
    }

    /**
     * @return str
     */
    public function getRadioGroupName()
    {
        return $this->radioGroupName;
    }

    /**
     * @param str $radioGroupName
     */
    public function setRadioGroupName($radioGroupName)
    {
        $this->radioGroupName = $radioGroupName;
    }

    /**
     * @return str
     */
    public function getParentResourceName()
    {
        return $this->parentResourceName;
    }

    /**
     * @param str $parentResourceName
     */
    public function setParentResourceName($parentResourceName)
    {
        $this->parentResourceName = $parentResourceName;
    }

    /**
     * @return str
     */
    public function getOveruseFeeDescription()
    {
        return $this->overuseFeeDescription;
    }

    /**
     * @param str $overuseFeeDescription
     */
    public function setOveruseFeeDescription($overuseFeeDescription)
    {
        $this->overuseFeeDescription = $overuseFeeDescription;
    }

    /**
     * @return float
     */
    public function getOveruseFee()
    {
        return $this->overuseFee;
    }

    /**
     * @param float $overuseFee
     */
    public function setOveruseFee($overuseFee)
    {
        $this->overuseFee = $overuseFee;
    }

    /**
     * @return int
     */
    public function getIsOveruseFeeTiered()
    {
        return $this->isOveruseFeeTiered;
    }

    /**
     * @param int $isOveruseFeeTiered
     */
    public function setIsOveruseFeeTiered($isOveruseFeeTiered)
    {
        $this->isOveruseFeeTiered = $isOveruseFeeTiered;
    }

    /**
     * @return int
     */
    public function getIsRecurringFeeTiered()
    {
        return $this->isRecurringFeeTiered;
    }

    /**
     * @param int $isRecurringFeeTiered
     */
    public function setIsRecurringFeeTiered($isRecurringFeeTiered)
    {
        $this->isRecurringFeeTiered = $isRecurringFeeTiered;
    }

    /**
     * @return int
     */
    public function getIsSetupFeeTiered()
    {
        return $this->isSetupFeeTiered;
    }

    /**
     * @param int $isSetupFeeTiered
     */
    public function setIsSetupFeeTiered($isSetupFeeTiered)
    {
        $this->isSetupFeeTiered = $isSetupFeeTiered;
    }

    /**
     * @return int
     */
    public function getParentDependentMultiplier()
    {
        return $this->parentDependentMultiplier;
    }

    /**
     * @param int $parentDependentMultiplier
     */
    public function setParentDependentMultiplier($parentDependentMultiplier)
    {
        $this->parentDependentMultiplier = $parentDependentMultiplier;
    }
}
