# Acronis\Cloud\Client\LocationsApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteLocationsByLocationId**](LocationsApi.md#deleteLocationsByLocationId) | **DELETE** /locations/{location_id} | LocationsByLocationId
[**getLocations**](LocationsApi.md#getLocations) | **GET** /locations | Locations
[**getLocationsByLocationId**](LocationsApi.md#getLocationsByLocationId) | **GET** /locations/{location_id} | LocationsByLocationId
[**getLocationsInfraByLocationId**](LocationsApi.md#getLocationsInfraByLocationId) | **GET** /locations/{location_id}/infra | LocationsInfraByLocationId
[**postLocations**](LocationsApi.md#postLocations) | **POST** /locations | Locations
[**putLocationsByLocationId**](LocationsApi.md#putLocationsByLocationId) | **PUT** /locations/{location_id} | LocationsByLocationId


# **deleteLocationsByLocationId**
> deleteLocationsByLocationId($location_id, $version)

LocationsByLocationId

Remove infrastructure location by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LocationsApi();
$location_id = "location_id_example"; // string | 
$version = 56; // int | Growing number of infrastructure location's version

try {
    $api_instance->deleteLocationsByLocationId($location_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling LocationsApi->deleteLocationsByLocationId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **location_id** | **string**|  |
 **version** | **int**| Growing number of infrastructure location&#39;s version |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getLocations**
> \Acronis\Cloud\Client\Model\Locations\LocationBatch getLocations($uuids, $if_modified_since)

Locations

Batch get of infrastructure locations

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LocationsApi();
$uuids = "uuids_example"; // string | Comma separated UUIDs of infrastructure locations
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getLocations($uuids, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LocationsApi->getLocations: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuids** | **string**| Comma separated UUIDs of infrastructure locations |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Locations\LocationBatch**](../Model/Locations/LocationBatch.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getLocationsByLocationId**
> \Acronis\Cloud\Client\Model\Locations\Location getLocationsByLocationId($location_id, $if_modified_since)

LocationsByLocationId

Get infrastructure location by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LocationsApi();
$location_id = "location_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getLocationsByLocationId($location_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LocationsApi->getLocationsByLocationId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **location_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Locations\Location**](../Model/Locations/Location.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getLocationsInfraByLocationId**
> \Acronis\Cloud\Client\Model\Infra\InfraList getLocationsInfraByLocationId($location_id, $if_modified_since)

LocationsInfraByLocationId

List infrastructure components that belong to the location

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LocationsApi();
$location_id = "location_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getLocationsInfraByLocationId($location_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LocationsApi->getLocationsInfraByLocationId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **location_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Infra\InfraList**](../Model/Infra/InfraList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postLocations**
> \Acronis\Cloud\Client\Model\Locations\Location postLocations($body)

Locations

Create new infrastructure location

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LocationsApi();
$body = new \Acronis\Cloud\Client\Model\Locations\LocationPost(); // \Acronis\Cloud\Client\Model\Locations\LocationPost | 

try {
    $result = $api_instance->postLocations($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LocationsApi->postLocations: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Acronis\Cloud\Client\Model\Locations\LocationPost**](../Model/Locations/LocationPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Locations\Location**](../Model/Locations/Location.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putLocationsByLocationId**
> \Acronis\Cloud\Client\Model\Locations\Location putLocationsByLocationId($location_id, $body)

LocationsByLocationId

Update infrastructure location by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\LocationsApi();
$location_id = "location_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Locations\LocationPut(); // \Acronis\Cloud\Client\Model\Locations\LocationPut | 

try {
    $result = $api_instance->putLocationsByLocationId($location_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling LocationsApi->putLocationsByLocationId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **location_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Locations\LocationPut**](../Model/Locations/LocationPut.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Locations\Location**](../Model/Locations/Location.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

