# Acronis\Cloud\Client\WellApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getWellKnownAppConfiguration**](WellApi.md#getWellKnownAppConfiguration) | **GET** /.well-known/app-configuration | WellKnownAppConfiguration
[**getWellKnownOpenIdConfiguration**](WellApi.md#getWellKnownOpenIdConfiguration) | **GET** /.well-known/openid-configuration | WellKnownOpenIdConfiguration


# **getWellKnownAppConfiguration**
> \Acronis\Cloud\Client\Model\AppConfiguration\AppConfiguration getWellKnownAppConfiguration()

WellKnownAppConfiguration

Get app configuration information (list of applications with their URLs)

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\WellApi();

try {
    $result = $api_instance->getWellKnownAppConfiguration();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling WellApi->getWellKnownAppConfiguration: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Acronis\Cloud\Client\Model\AppConfiguration\AppConfiguration**](../Model/AppConfiguration/AppConfiguration.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getWellKnownOpenIdConfiguration**
> \Acronis\Cloud\Client\Model\OpenIdConfiguration\OpenIdConfiguration getWellKnownOpenIdConfiguration()

WellKnownOpenIdConfiguration

OpenID Provider's configuration information. See https://openid.net/specs/openid-connect-discovery-1_0.html

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\WellApi();

try {
    $result = $api_instance->getWellKnownOpenIdConfiguration();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling WellApi->getWellKnownOpenIdConfiguration: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Acronis\Cloud\Client\Model\OpenIdConfiguration\OpenIdConfiguration**](../Model/OpenIdConfiguration/OpenIdConfiguration.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

