<?php
/**
 * TenantPricingSettings
 *
 * PHP version 5
 *
 * @category Class
 * @package  Acronis\Cloud\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Management API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 2
 *
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Acronis\Cloud\Client\Model\Pricing;

use Acronis\Cloud\Client\BaseModel;
/**
 * TenantPricingSettings Class Doc Comment
 *
 * @category    Class
 * @package     Acronis\Cloud\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class TenantPricingSettings extends BaseModel
{
    const DISCRIMINATOR = null;

    /**
     * The original name of the model.
     * @var string
     */
    protected static $swaggerModelName = 'Pricing\TenantPricingSettings';

    /**
     * Array of property to type mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerTypes()
    {
        return [
            'mode' => '\Acronis\Cloud\Client\Model\Pricing\TenantPricingSettingsMode',
            'currency' => 'object',
            'version' => 'int',
            'production_start_date' => 'string'
        ];
    }


    /**
     * Array of property to format mappings. Used for (de)serialization
     * @return array
     */
    public static function swaggerFormats()
    {
        return [
            'mode' => null,
            'currency' => null,
            'version' => 'int32',
            'production_start_date' => null
        ];
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @return array
     */
    public static function attributeMap()
    {
        return [
            'mode' => 'mode',
            'currency' => 'currency',
            'version' => 'version',
            'production_start_date' => 'production_start_date'
        ];
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @return array
     */
    public static function setters()
    {
        return [
            'mode' => 'setMode',
            'currency' => 'setCurrency',
            'version' => 'setVersion',
            'production_start_date' => 'setProductionStartDate'
        ];
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @return array
     */
    public static function getters()
    {
        return [
            'mode' => 'getMode',
            'currency' => 'getCurrency',
            'version' => 'getVersion',
            'production_start_date' => 'getProductionStartDate'
        ];
    }

    /**
     * Array of attributes to checkers functions (for deserialization of responses)
     * @return array
     */
    public static function checkers()
    {
        return [
            'mode' => 'hasMode',
            'currency' => 'hasCurrency',
            'version' => 'hasVersion',
            'production_start_date' => 'hasProductionStartDate'
        ];
    }

    /**
     * Array of attributes to validators functions (for deserialization of responses)
     * @return array
     */
    public static function validators() {
        return [
            'mode' => 'validateMode',
            'currency' => 'validateCurrency',
            'version' => 'validateVersion',
            'production_start_date' => 'validateProductionStartDate'
        ];
    }





    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];
        if (!empty($this->validateMode())) {
            $invalid_properties[] = $this->validateMode();
        }
        if (!empty($this->validateCurrency())) {
            $invalid_properties[] = $this->validateCurrency();
        }
        if (!empty($this->validateVersion())) {
            $invalid_properties[] = $this->validateVersion();
        }
        if (!empty($this->validateProductionStartDate())) {
            $invalid_properties[] = $this->validateProductionStartDate();
        }
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        if (!empty($this->validateMode())) {
            return false;
        }
        if (!empty($this->validateCurrency())) {
            return false;
        }
        if (!empty($this->validateVersion())) {
            return false;
        }
        if (!empty($this->validateProductionStartDate())) {
            return false;
        }
        return true;
    }


    /**
     * Gets mode
     * @return \Acronis\Cloud\Client\Model\Pricing\TenantPricingSettingsMode
     */
    public function getMode()
    {
        return $this->offsetGet('mode');
    }

    /**
     * Checks mode
     * @return boolean
     */
    public function hasMode()
    {
        return $this->offsetExists('mode');
    }

    /**
     * Sets mode
     * @param \Acronis\Cloud\Client\Model\Pricing\TenantPricingSettingsMode $mode
     * @return $this
     */
    public function setMode($mode)
    {
        $this->offsetSet('mode', $mode);

        return $this;
    }

    /**
     * Unset mode
     */
    public function unsetMode() {
        $this->offsetUnset('mode');
    }

    /**
     * Valid mode
     * @return array|boolean
     */
    public function validateMode()
    {
        if (!$this->offsetExists('mode')) {
            return "Property 'mode' was not initialized.";
        }
        return false;
    }


    /**
     * Gets currency
     * @return object
     */
    public function getCurrency()
    {
        return $this->offsetGet('currency');
    }

    /**
     * Checks currency
     * @return boolean
     */
    public function hasCurrency()
    {
        return $this->offsetExists('currency');
    }

    /**
     * Sets currency
     * @param object $currency Currency of all offering item prices for this tenant
     * @return $this
     */
    public function setCurrency($currency)
    {
        $this->offsetSet('currency', $currency);

        return $this;
    }

    /**
     * Unset currency
     */
    public function unsetCurrency() {
        $this->offsetUnset('currency');
    }

    /**
     * Valid currency
     * @return array|boolean
     */
    public function validateCurrency()
    {
        if (!$this->offsetExists('currency')) {
            return "Property 'currency' was not initialized.";
        }
        return false;
    }


    /**
     * Gets version
     * @return int
     */
    public function getVersion()
    {
        return $this->offsetGet('version');
    }

    /**
     * Checks version
     * @return boolean
     */
    public function hasVersion()
    {
        return $this->offsetExists('version');
    }

    /**
     * Sets version
     * @param int $version Auto-incremented entity version
     * @return $this
     */
    public function setVersion($version)
    {
        $this->offsetSet('version', $version);

        return $this;
    }

    /**
     * Unset version
     */
    public function unsetVersion() {
        $this->offsetUnset('version');
    }

    /**
     * Valid version
     * @return array|boolean
     */
    public function validateVersion()
    {
        if (!$this->offsetExists('version')) {
            return "Property 'version' was not initialized.";
        }
        return false;
    }


    /**
     * Gets production_start_date
     * @return string
     */
    public function getProductionStartDate()
    {
        return $this->offsetGet('production_start_date');
    }

    /**
     * Checks production_start_date
     * @return boolean
     */
    public function hasProductionStartDate()
    {
        return $this->offsetExists('production_start_date');
    }

    /**
     * Sets production_start_date
     * @param string $production_start_date Production pricing mode start date (timestamp).
     * @return $this
     */
    public function setProductionStartDate($production_start_date)
    {
        if ((strlen($production_start_date) > 32)) {
            throw new \InvalidArgumentException('invalid length for $production_start_date when calling TenantPricingSettings., must be smaller than or equal to 32.');
        }
        if ((strlen($production_start_date) < 19)) {
            throw new \InvalidArgumentException('invalid length for $production_start_date when calling TenantPricingSettings., must be bigger than or equal to 19.');
        }
        if ((!preg_match("/\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?([\\+\\-]\\d{2}\\:\\d{2})?/", $production_start_date))) {
            throw new \InvalidArgumentException("invalid value for $production_start_date when calling TenantPricingSettings., must conform to the pattern /\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?([\\+\\-]\\d{2}\\:\\d{2})?/.");
        }

        $this->offsetSet('production_start_date', $production_start_date);

        return $this;
    }

    /**
     * Unset production_start_date
     */
    public function unsetProductionStartDate() {
        $this->offsetUnset('production_start_date');
    }

    /**
     * Valid production_start_date
     * @return array|boolean
     */
    public function validateProductionStartDate()
    {
        if (!$this->offsetExists('production_start_date')) {
            return "Property 'production_start_date' was not initialized.";
        }
        if ($this->offsetExists('production_start_date') && strlen($this->offsetGet('production_start_date')) > 32) {
            return "invalid value for 'production_start_date', the character length must be smaller than or equal to 32.";
        }
        if ($this->offsetExists('production_start_date') && strlen($this->offsetGet('production_start_date')) < 19) {
            return "invalid value for 'production_start_date', the character length must be bigger than or equal to 19.";
        }
        if ($this->offsetExists('production_start_date') && !preg_match("/\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?([\\+\\-]\\d{2}\\:\\d{2})?/", $this->offsetGet('production_start_date'))) {
            return "invalid value for 'production_start_date', must be conform to the pattern /\\d{4}-\\d{2}-\\d{2}T\\d{2}:\\d{2}:\\d{2}(\\.\\d+)?([\\+\\-]\\d{2}\\:\\d{2})?/.";
        }
        return false;
    }

}


