<?php


use Acronis\Common\CodeGenerator\OfferingItems\RequirementsInterpolator;

class RequirementsInterpolatorTest extends \PHPUnit\Framework\TestCase
{
    /**
     * @dataProvider templatesDataProvider
     */
    public function testInterpolate($template, $item, $additional, $expected)
    {
        $interpolator = new RequirementsInterpolator();

        $actual = $interpolator->interpolate($template, $item, $additional);

        $this->assertEquals($expected, $actual);
    }

    public function templatesDataProvider()
    {
        return [
            'Simple interpolation' => [
                'template' => 'Hello, {{ item.name }}!',
                'item' => ['name' => 'World'],
                'additional' => null,
                'expected' => 'Hello, World!'
            ],
            'Building counter name for storage oi from requirements' => [
                'template' => '{{ item | counterName }}',
                'item' => [
                    'Offering item name' => 'adv_storage',
                    'Measurement unit' => 'bytes',
                ],
                'additional' => null,
                'expected' => 'AdvStorageUsage'
            ],
            'Building counter name for count oi from requirements' => [
                'template' => '{{ item | counterName }}',
                'item' => [
                    'Offering item name' => 'adv_vms',
                    'Measurement unit' => 'quantity',
                ],
                'additional' => null,
                'expected' => 'AdvVmsCount'
            ]
        ];
    }
}